// C Header File
// Created 24/08/2002; 22:00:12

#ifndef SPECIAL_H
#define SPECIAL_H

// global constants


// colonne
#define  ti89col_haut     	0x0001
//#define  ti89col_bas  			0x0004
#define  ti89col_gauche			0x0002
#define  ti89col_droite			0x0008
#define  ti92col_haut     	0x0020
//#define  ti92col_bas  			0x0080
#define  ti92col_gauche			0x0010
#define  ti92col_droite			0x0040
#define	 ti89col_esc				0x0001
#define	 ti92col_esc				0x0040
#define  ti89col_2nd   			0x0010
#define  ti92col_2nd    		0x0001
	
// rang
#define	 rg_fleche					0xFFFE
#define	 ti89rg_esc					0xFFBF
#define	 ti92rg_esc					0xFEFF
#define	 rg_2nd         		0xFFFE



	


#define  vit  							4 // vitesse du vsso
#define  vit_canon					0.1
#define  espace_balle				6 // reprsente la vitesse des balles et il faut qu'elles ayent plus vite que le vsso
#define	 nb_balle						7 // attention limit  255
#define taille_vsso					5 // nvelle cste pour la taille du vsso pr raison pratique
#define taille_balle				2
#define taille_missile			3
#define taille_soucoupe			3
#define vitm								4 // vitesse des ennemis, celle des gros, vit min (4)  trouver car sinon prend pas toutes les dir
#define region_balle				7
#define region_vsso					5
// maintenant on en fait une variable pour pouvoir choisir la difficult
//#define ralenti							13 //permet de ralentir les ennemis par rapport au vaisseau
#define tps_eclosion				73
#define tps_prem_eclosion		213
#define max_explo						7
#define tps_explo						4 // attention la stucture est limite en taille

#define vit_pondeuse				1 // vitesse de dplacement de la pondeuse

#define pt_taille						13
#define pt_forme						17
#define pt_defaut						23

//#define vit_anim // vitesse de dplacement de l'animation quand le joueur a gagn

#define r1									13
#define nb1									7
#define v1									0//.6
#define r2									17
#define nb2									7
#define v2									-0//.5
#define r3									21
#define nb3									13
#define v3									0.8
#define nb_tour							13

/* beaucoup de ces paramtres je les ai rgls  taton pour trouver les meilleures valeurs
	et rendre le jeu jouable 
	je pense que ces paramtres sont bons mais il peut exister une meilleure combinaison si 
	tu trouves envoie moi un email
	attention ces paramtres sont fai pour voluer au cours de la programetion car il 
	reste encore pas mal de truc mais on arrive bientt  la fin du tunnel
*/

// numrations
enum Forme {t1, t2, t3, t4, m, s}; //  m = missile, s = soucoupe
enum Taille {petit, moyen, gros};
enum direction {haut, gauche, bas, droite};
enum difficulte {easy = 19, middle = 13, hard = 7};// 7 = dur; 13 = moy; 19 = facile

/*
Caractristique des ennemis
t1: ennemi batard qui suit une trajectoire fixe et tue le joueur s'il le heurte
t2: ennemi qui choisit la direction pour se rapprocher le plus vite du joueur mais seulement  l'intrieur du cadre
t3: ennemi qui suit une trajectoire fixe et quand il est tu par le joueur, il envoie un missile dans la direction du joueur
t4: ennemi = t2 + t3, suit le joueur et envoie un missile quand il est tu
m: le missile de t3 et t4
s: soucoupe pond des oeufs  chaque chgt de dir puis s'arrte de pondre
*/

// Structure et nveau type

typedef struct {
	short x : 9;
	short y : 8;
} POS;

typedef struct {
	unsigned char largeur,hteur;
/*	unsigned char largeur : 8;
		unsigned char hteur : 7;	on economise rien on garde le plus simple */
} GRDEUR;
  
typedef struct {
	unsigned char taille : 2; // 5 car si 4 on a 2^4 = 16 et dc a va de 0  15
	unsigned char forme : 3;
} TYPE;

typedef struct {
	POS posi;
	float dir;
	unsigned char etat : 2; // etat 0:oeuf, 1:vivant, 2:mort
	TYPE type;
} CARACT;

typedef struct {
	POS posi;
	unsigned char etat : 3; // 0 l'explosion n'est plus visible
} EXPLO;


// Dclaration des procdures

inline void dessinvsso (POS , float);

void dessinennemi (POS , TYPE);

inline void efface (POS , float);

inline void affiche (POS , float );

inline void dessineexplo (POS );

void transfert (POS *, unsigned char);

void deplavsso (POS *, float); 

void deplacanon (POS , float *, float) ;

short deplaennemi (POS *, float *, TYPE, POS);

void chargeniv (char , char , char , char , POS *, float *, short, unsigned long int, short); 
 
inline void tracecadre();

inline void init_taille();

inline void init_posi();

inline void init_forme(char , char , char , char);

inline void init_explo();

inline short collision (POS , POS , unsigned char ); 

inline short arret() ;

inline void tracecadre() ;

inline float hasard() ;

void naissance (CARACT *) ;

void init_oeuf_s (CARACT *, char ) ;

void teleport (POS *, float *) ;

inline void dessine_balle (POS );

inline void dessine_pondeuse (POS);

inline void depla_pondeuse ();

void attente (short);

void affichage (short, unsigned long int, short);

void affichage_pt (unsigned long int);

void victoire (POS, float, short, unsigned long int, short);

void perdu (short, POS, float, unsigned long int);

short deplaennemi2 (POS *, float *, TYPE);

char presentation ();

void image();

char menu ();

void menuaide();

void menuoption();

void propos();

void aide ();

void tutorial();

void gestion_tueur(short, POS);

#endif
